{                       20                      }
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Nastmapu1: TMenuItem;
    Uloitvstupnsoubor1: TMenuItem;
    Konec1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Label1: TLabel;
    Image1: TImage;
    Legenda1: TMenuItem;
    procedure Konec1Click(Sender: TObject);
    procedure Nastmapu1Click(Sender: TObject);
    procedure Uloitvstupnsoubor1Click(Sender: TObject);
    procedure Legenda1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  soubor, soubor2, radek: string; //
  delka_radku, pocet_radku, i, pocetz, pocetr, znakp, mezera, X, Y: integer;
  znak: char;
  mapa, vystup: TextFile; // vstupni a vystupni soubor
implementation

uses Unit2;

{$R *.dfm}

procedure int;    // procedura na inicializaci, vynulovani promennych
begin
 pocet_radku:=1;
 delka_radku:=0;
 pocetz:=0;
 pocetr:=1;
 mezera:=5;
 X:=0;
 Y:=0;
 znakp:=0;
end;

procedure vykresleni_mrizky;
begin
 with Form1.Image1 do
 begin
  Width:=delka_radku*20;  //nastaveni optimalni sirky a delky platna pro vykresleni mapy
  Height:=pocet_radku*20;

  // vykresleni optimalni mrizky pro mapu
  with Canvas do
  begin
   MoveTo(0,0);
   // smazani platna
   Pen.Color:=clWhite;
   for i:=1 to Height do
   begin
    LineTo(Width, i);
    MoveTo(0,i);
   end;
   Pen.Color:=clBlack;

   Canvas.MoveTo(0,0);
      // oramovani
   LineTo(Width-1,0);        // nahore
   LineTo(Width-1, Height);  // vpravo
   MoveTo(Width-1, Height-1);
   LineTo(0, Height-1);            // dole
   LineTo(0, 0);             // vlevo

      // vykresleni svislych car
   for i:=1 to delka_radku do
   begin
    MoveTo(20*i, 0);
    LineTo(20*i, Height);
   end;
      // vykresleni vodorovnych car
   for i:=1 to pocet_radku do
   begin
    MoveTo(0, 20*i);
    LineTo(Width, 20*i);
   end;
   end;
  end;
end;

procedure vykresleni_mapy;     // vykresli znaky na platno = do mrizky
begin
 Reset(mapa);
 while not(eof(mapa)) do
 begin
  Readln(mapa, radek);  // nacte jeden cely radek

  for i:=0 to Length(radek) do  // zpracovava cely radek, tj. zobrazuje znak po znaku na platno
  begin
   if (delka_radku<pocetz) then  // pokud je radek u konce = potreba delat vetsi mezery na ose Y
   begin
    inc(pocetr);
    pocetz:=0;
    mezera:=pocetr*20-15;  // vypocita aktualni mezeru na ose Y
   end;
   with Form1.Image1.Canvas do
   begin
    Font.Style:=[fsBold];
    if radek[i]='.' then Font.Color:=clRed;
    if radek[i]=':' then Font.Color:=clGreen;
    TextOut((pocetz*20-12), mezera, radek[i]);  // zapise urcity znak z radku
    Font.Color:=clBlack;                        // s aktualni mezerou na X
   end;
   inc(pocetz);
  end;
 end;
 CloseFile(mapa);
end;

procedure vystupni_soubor;
begin
 while not(eof(mapa)) do    // cte znaky a uklada jejich polohu
 begin
  Read(mapa, znak);         // precte znak
  inc(znakp);               // dalsi znak
  if (znak<>'x') and (znak<>'X') and (znak<>chr(13)) and (znak<>chr(10))then    // program bere pouze znaky, ktere nejsou X, x, chr(13) a chr(10)
  begin
   Y:=pocet_radku-(znakp div delka_radku)+1;  // zjisti souradnice Y, levy dolni roh = 0,0
   X:=znakp mod delka_radku+1;                // zjisti souradnici X
  end;
 end;
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
 Close();
end;

procedure TForm1.Nastmapu1Click(Sender: TObject);
begin
 int;
 OpenDialog1.Execute;         // otevre opendialog
 soubor:=OpenDialog1.FileName; // ulozi si cestu
 if soubor<>'' then            // osetreni chyby = kdyby byla neexistovala soubor
 begin
  AssignFile(mapa, soubor);
  Reset(mapa);

  Readln(mapa, radek); //precte jeden radek
  delka_radku:=Length(radek); //ziska pocet znaku na radku

  while not(eof(mapa)) do  //cte soubor dokud neni jeho konec
  begin
   Readln(mapa);
   inc(pocet_radku);  //a kazdy novy radek se zapocte
  end;
  CloseFile(mapa);

  vykresleni_mrizky;
  vykresleni_mapy;
 end; 
end;

procedure TForm1.Uloitvstupnsoubor1Click(Sender: TObject);
begin
 SaveDialog1.Execute;         // otevre savedialog
 soubor2:=SaveDialog1.FileName; // ulozi si z nej cestu
 if soubor2<>'' then
 begin
  AssignFile(vystup, soubor2);
  Rewrite(vystup);              // otevre a smaze soubor, pokud neexistuje tak vytvori
  Reset(mapa);                  // otevre soubor s mapou
  vystupni_soubor;              // bude heldat souradnice vech znak vyjma X, x
  CloseFile(vystup);            // zavre
  CloseFile(mapa);              // zavre soubor s mapou
 end;
end;

procedure TForm1.Legenda1Click(Sender: TObject);
begin
 Form2.Visible:=true;
 Form2.Show;
end;

end.
